function boot_max = func_Bootmax(select_rule,n,M,e_WY,e_WM,sign_theta,abs_theta,e_one,ghat,sigma)

    boot_max = 0;
    if select_rule(1)
        boot_max = max(boot_max,sqrt(n)*(-e_WY*sign_theta-e_one'*ghat(1))./sigma(1));
    end
    if select_rule(2)
        boot_max = max(boot_max,sqrt(n)*(e_WY*sign_theta-abs_theta-e_one'*ghat(2))./sigma(2));            
    end                  
    mom_index = 2;        
    for k = 1:size(M,2)
        M_one_list = combnk(1:size(M,2),k);            
        for i_com = 1:size(M_one_list,1)
            M_one = ismember(1:size(M,2),M_one_list(i_com,:))'-.5;
            if select_rule(mom_index)
                boot_max = max(boot_max,sqrt(n)*(-e_WY*sign_theta-e_WM*M_one*abs_theta-e_one'*ghat(mom_index))./sigma(mom_index));
            end     
            mom_index = mom_index+1;
        end
    end      
end